*  TESTHC11.ASM - Test file for 68HC11 disassembler
*
*  31-MAY-93 BY JOHN HARTMAN
*  22-JUL-93 JLH Correct various errors in numerical order of op-codes
*
*  EQUATES FOR ADDRESS MODES
NN      EQU     $12     IMMEDIATE 8
NNNN    EQU     $1234   IMMEDIATE 16
DD      EQU     $34     DIRECT PAGE
EEEE    EQU     $1234   EXTENDED
MM      EQU     $55     MASK

*  Map page 1
        ORG     $1000
LLLL    NOP             //01
        IDIV            //02
        FDIV            //03
        LSRD            //04
        ASLD            //05
        TAP             //06
        TPA             //07
        INX             //08
        DEX             //09
        CLV             //0A
        SEV             //0B
        CLC             //0C
        SEC             //0D
        CLI             //0E
        SEI             //0F

        SBA             //10
        CBA             //11
        BRSET   DD MM LLLL      //12
        BRCLR   DD MM LLL2      //13
        BSET    DD MM   //14
        BCLR    DD MM   //15
LLL2    TAB             //16
        TBA             //17
*       "PG2"           //18
        DAA             //19
*       "PG3"           //1A
        ABA             //1B
        BSET    DD,X MM //1C
        BCLR    DD,X MM //1D
        BRSET   DD,X MM LLLL //1E
        BRCLR   DD,X MM LLLL //1F

L20     BRA     LLLL    //20
        BRN     LLLL    //21
        BHI     LLLL    //22
        BLS     LLLL    //23
        BCC     LLLL    //24
        BCS     LLLL    //25
        BNE     LLLL    //26
        BEQ     LLLL    //27
        BVC     LLLL    //28
        BVS     LLLL    //29
        BPL     LLLL    //2A
        BMI     LLLL    //2B
        BGE     LLLL    //2C
        BLT     LLLL    //2D
        BGT     LLLL    //2E
        BLE     LLLL    //2F

        TSX             //30
        INS             //31
        PULA            //32
        PULB            //33
        DES             //34
        TXS             //35
        PSHA            //36
        PSHB            //37
        PULX            //38
        RTS             //39
        ABX             //3A
        RTI             //3B
        PSHX            //3C
        MUL             //3D
        WAI             //3E
        SWI             //3F

L40     NEGA            //40
*       undefined       //41
*       undefined       //42
        COMA            //43
        LSRA            //44
*       undefined       //45
        RORA            //46
        ASRA            //47
        ASLA            //48
        ROLA            //49
        DECA            //4A
*       undefined       //4B
        INCA            //4C
        TSTA            //4D
*       undefined       //4E
        CLRA            //4F

        NEGB            //50
*       undefined       //51
*       undefined       //52
        COMB            //53
        LSRB            //54
*       undefined       //55
        RORB            //56
        ASRB            //57
        ASLB            //58
        ROLB            //59
        DECB            //5A
*       undefined       //5B
        INCB            //5C
        TSTB            //5D
*       undefined       //5E
        CLRB            //5F

        NEG     NN,X    //60
*       undefined       //61
*       undefined       //62
        COM     NN,X    //63
        LSR     NN,X    //64
*       undefined       //65
        ROR     NN,X    //66
        ASR     NN,X    //67
        ASL     NN,X    //68
        ROL     NN,X    //69
        DEC     NN,X    //6A
*       undefined       //6B
        INC     NN,X    //6C
        TST     NN,X    //6D
        JMP     NN,X    //6E
        CLR     NN,X    //6F

        NEG     EEEE    //70
*       undefined       //71
*       undefined       //72
        COM     EEEE    //73
        LSR     EEEE    //74
*       undefined       //75
        ROR     EEEE    //76
        ASR     EEEE    //77
        ASL     EEEE    //78
        ROL     EEEE    //79
        DEC     EEEE    //7A
*       undefined       //7B
        INC     EEEE    //7C
        TST     EEEE    //7D
        JMP     EEEE    //7E
        CLR     EEEE    //7F

L80     SUBA    #NN     //80
        CMPA    #NN     //81
        SBCA    #NN     //82
        SUBD    #NNNN   //83
        ANDA    #NN     //84
        BITA    #NN     //85
        LDAA    #NN     //86
*       undefined       //87
        EORA    #NN     //88
        ADCA    #NN     //89
        ORAA    #NN     //8A
QQQ     ADDA    #NN     //8B
        CPX     #NNNN   //8C
        BSR     QQQ     //8D
        LDS     #NNNN   //8E
        XGDX            //8F

        SUBA    DD      //90
        CMPA    DD      //91
        SBCA    DD      //92
        SUBD    DD      //93
        ANDA    DD      //94
        BITA    DD      //95
        LDAA    DD      //96
        STAA    DD      //97
        EORA    DD      //98
        ADCA    DD      //99
        ORAA    DD      //9A
        ADDA    DD      //9B
        CPX     DD      //9C
        JSR     DD      //9D
        LDS     DD      //9E
        STS     DD      //9F

        SUBA    NN,X    //A0
        CMPA    NN,X    //A1
        SBCA    NN,X    //A2
        SUBD    NN,X    //A3
        ANDA    NN,X    //A4
        BITA    NN,X    //A5
        LDAA    NN,X    //A6
        STAA    NN,X    //A7
        EORA    NN,X    //A8
        ADCA    NN,X    //A9
        ORAA    NN,X    //AA
        ADDA    NN,X    //AB
        CPX     NN,X    //AC
        JSR     NN,X    //AD
        LDS     NN,X    //AE
        STS     NN,X    //AF

        SUBA    EEEE    //B0
        CMPA    EEEE    //B1
        SBCA    EEEE    //B2
        SUBD    EEEE    //B3
        ANDA    EEEE    //B4
        BITA    EEEE    //B5
        LDAA    EEEE    //B6
        STAA    EEEE    //B7
        EORA    EEEE    //B8
        ADCA    EEEE    //B9
        ORAA    EEEE    //BA
        ADDA    EEEE    //BB
        CPX     EEEE    //BC
        JSR     EEEE    //BD
        LDS     EEEE    //BE
        STS     EEEE    //BF

LC0     SUBB    #NN     //C0
        CMPB    #NN     //C1
        SBCB    #NN     //C2
        ADDD    #NNNN   //C3
        ANDB    #NN     //C4
        BITB    #NN     //C5
        LDAB    #NN     //C6
*       undefined       //C7
        EORB    #NN     //C8
        ADCB    #NN     //C9
        ORAB    #NN     //CA
        ADDB    #NN     //CB
        LDD     #NNNN   //CC
*       "PAGE4"         //CD
        LDX     #NNNN   //CE
        STOP            //CF

        SUBB    DD      //D0
        CMPB    DD      //D1
        SBCB    DD      //D2
        ADDD    DD      //D3
        ANDB    DD      //D4
        BITB    DD      //D5
        LDAB    DD      //D6
        STAB    DD      //D7
        EORB    DD      //D8
        ADCB    DD      //D9
        ORAB    DD      //DA
        ADDB    DD      //DB
        LDD     DD      //DC
        STD     DD      //DD
        LDX     DD      //DE
        STX     DD      //DF

        SUBB    NN,X    //E0
        CMPB    NN,X    //E1
        SBCB    NN,X    //E2
        ADDD    NN,X    //E3
        ANDB    NN,X    //E4
        BITB    NN,X    //E5
        LDAB    NN,X    //E6
        STAB    NN,X    //E7
        EORB    NN,X    //E8
        ADCB    NN,X    //E9
        ORAB    NN,X    //EA
        ADDB    NN,X    //EB
        LDD     NN,X    //EC
        STD     NN,X    //ED
        LDX     NN,X    //EE
        STX     NN,X    //EF

        SUBB    EEEE    //F0
        CMPB    EEEE    //F1
        SBCB    EEEE    //F2
        ADDD    EEEE    //F3
        ANDB    EEEE    //F4
        BITB    EEEE    //F5
        LDAB    EEEE    //F6
        STAB    EEEE    //F7
        EORB    EEEE    //F8
        ADCB    EEEE    //F9
        ORAB    EEEE    //FA
        ADDB    EEEE    //FB
        LDD     EEEE    //FC
        STD     EEEE    //FD
        LDX     EEEE    //FE
        STX     EEEE    //FF

* Map page 2
LP0     INY             //08
        DEY             //09

        BSET    DD,Y MM         //1C
        BCLR    DD,Y MM         //1D
        BRSET   DD,Y MM ZZZ     //1E
        BRCLR   DD,Y MM ZZZ     //1F

ZZZ     TSY             //30
        TYS             //35
        PULY            //38
        ABY             //3A
        PSHY            //3C

        NEG     NN,Y    //60
*       undefined       //61
*       undefined       //62
        COM     NN,Y    //63
        LSR     NN,Y    //64
*       undefined       //65
        ROR     NN,Y    //66
        ASR     NN,Y    //67
        ASL     NN,Y    //68
        ROL     NN,Y    //69
        DEC     NN,Y    //6A
*       undefined       //6B
        INC     NN,Y    //6C
        TST     NN,Y    //6D
        JMP     NN,Y    //6E
        CLR     NN,Y    //6F

LP80    CPY     #NNNN   //8C
        XGDY            //8F

        CPY     DD      //9C

        SUBA    NN,Y    //A0
        CMPA    NN,Y    //A1
        SBCA    NN,Y    //A2
        SUBD    NN,Y    //A3
        ANDA    NN,Y    //A4
        BITA    NN,Y    //A5
        LDAA    NN,Y    //A6
        STAA    NN,Y    //A7
        EORA    NN,Y    //A8
        ADCA    NN,Y    //A9
        ORAA    NN,Y    //AA
        ADDA    NN,Y    //AB
        CPY     NN,Y    //AC
        JSR     NN,Y    //AD
        LDS     NN,Y    //AE
        STS     NN,Y    //AF

        CPY     EEEE    //BC

        LDY     #NNNN   //CE

        LDY     DD      //DE
        STY     DD      //DF

        SUBB    NN,Y    //E0
        CMPB    NN,Y    //E1
        SBCB    NN,Y    //E2
        ADDD    NN,Y    //E3
        ANDB    NN,Y    //E4
        BITB    NN,Y    //E5
        LDAB    NN,Y    //E6
        STAB    NN,Y    //E7
        EORB    NN,Y    //E8
        ADCB    NN,Y    //E9
        ORAB    NN,Y    //EA
        ADDB    NN,Y    //EB
        LDD     NN,Y    //EC
        STD     NN,Y    //ED
        LDY     NN,Y    //EE
        STY     NN,Y    //EF

        LDY     EEEE    //FE
        STY     EEEE    //FF

* OPCODE MAP PAGE 3
LQ0     CPD     #NNNN   //83

        CPD     DD      //93

        CPD     NN,X    //A3
        CPY     NN,X    //AC

        CPD     EEEE    //B3

        LDY     NN,X    //EE
        STY     NN,X    //EF

* OPCODE MAP PAGE 4
LR0     CPD     NN,Y    //A3
        CPX     NN,Y    //AC

        LDX     NN,Y    //EE
ZED     STX     NN,Y    //EF

        END	LLLL
